#include<stdio.h>
#include "mpi.h"


int main(int argc,char *argv[]){
  char s[80];
  int sz,rank;
  MPI_Status status;

  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD,&sz);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);

  if (1>=sz){
    MPI_Finalize();
    exit(-1);
  }
  if (0!=rank){
    sprintf(s,"Greetings from process %d",rank);
    MPI_Send(s,80,MPI_CHAR,0,0,MPI_COMM_WORLD);
    MPI_Barrier(MPI_COMM_WORLD);
  }
  else {
    int i;
    for (i=1;i<sz;i++){
      MPI_Recv(s,80,MPI_CHAR,i,0,MPI_COMM_WORLD,&status);
      printf("%s\n",s);
    }
    scanf("%s",s);
    printf("%s\n",s);
    MPI_Barrier(MPI_COMM_WORLD);
  }
  MPI_Finalize();
  return 0;
}

